<template>
	<div class="form-submit">
		<div class="i-layout-page-header">
			<PageHeader class="product_tabs" hidden-breadcrumb>
				<div slot="title">
					<router-link :to="{ path: `${roterPre}/erp/out_list` }">
						<!-- <Button icon="ios-arrow-back" size="small" class="mr20"
              >返回</Button
            > -->
						<div class="font-sm after-line">
							<span class="iconfont iconfanhui"></span>
							<span class="pl10">返回</span>
						</div>
					</router-link>
					<span v-text="
              $route.query.id !== '0' ? '编辑盘点单' : '添加盘点单'
            " class="mr20 ml16"></span>
				</div>
			</PageHeader>
		</div>
		<Card :bordered="false" dis-hover class="ivu-mt">
			<Form class="formValidate mt20" ref="formValidate" :rules="formValidate.id == 0?ruleValidate:ruleValidate1" :model="formValidate"
				:label-width="labelWidth" :label-position="labelPosition" @submit.native.prevent>
				<Row :gutter="24" type="flex">
					<Col span="24">
					<FormItem label="仓库：" prop="wid" v-if="formValidate.outType == 0">
						<el-cascader placeholder="请选择仓库" class="input-add" size="mini" v-model="formValidate.wid"
							:options="data1" :props="props" @change="checkOutWare" filterable clearable v-width="'400'" :disabled="formValidate.id != 0">
						</el-cascader>
					</FormItem>
					</Col>
					<Col span="24">
					<FormItem label="创建人：" prop="create_uid" v-if="formValidate.wid != 0">
						<el-cascader placeholder="请选择创建人" class="input-add" size="mini"
							v-model="formValidate.create_uid" :options="authList" :props="propsss"
							@change="userSearchsss" filterable clearable v-width="'400'" :disabled="formValidate.id != 0">
						</el-cascader>
					</FormItem>
					</Col>
					<Col span="24">
					<FormItem label="商品：" prop="goods">
						<Card>
							<div class="user-info" v-for="(goods,gindex) in chooseGoods">
								<Button type="primary" @click="delGood(gindex)" class="del-btn">删除</Button>
								<div class="section-hd">{{goods.product_name}}</span> </div>
								<div v-if="goods.batchs.length > 0" v-for="(item,index) in goods.batchs" class="section">
									<div class="section-bd">
										<div class="item">
											<div>批次编号：</div>
											<div class="value">{{ item.batch_code || '/'}}</div>
										</div>
										<div class="item">
											<div>库存：</div>
											<div class="value">{{ item.product_num}}</div>
										</div>
										<div class="item">
											<div>单位：</div>
											<div class="value">{{ item.unit_name}}</div>
										</div>
										<div class="item">
											<div>实盘：</div>
											<div class="value"><Input
													v-model="chooseGoods[gindex].batchs[index].stockValue"
													placeholder="请输入数量" v-width="'150'" type="number"
													@on-blur="jyNum(item.product_num,chooseGoods[gindex].batchs[index].stockValue,item)" />
											</div>
										</div>
										
									</div>

								</div>
							</div>
						</Card>
						<Button type="primary" class="submission" style="margin-top:20px;" @click="getGoods()"
							>添加商品</Button>
					</FormItem>
					</Col>
				</Row>
			</Form>
		</Card>
		<Card :bordered="false" dis-hover class="fixed-card"
			:style="{ left: `${!menuCollapse ? '200px' : isMobile ? '0' : '80px'}` }">
			<Form>
				<FormItem>
					<Button type="primary" class="submission" @click="handleSubmit('formValidate')">保存</Button>
				</FormItem>
			</Form>
		</Card>
		<pdgoods ref="pdgoods" @setGoods="setGoods"></pdgoods>
	</div>
</template>

<script>
	import {
		mapState,
		mapMutations
	} from "vuex";
	import {
		staffListInfo
	} from "@/api/store";
	import {
		getGodownList,
		createGodown,
		getGodownInfo,
		getUserList,
		getOutGoods,
		createWant,
		getWantInfo,
		getProductBatch,
		createOut,
		editOut,
		getOutInfo,
		saveInventory
	} from "@/api/erp";
	import {
		keyApi,
		storeGetInfoApi,
		cityApi,
		storeUpdateApi,
		cascaderList
	} from '@/api/store';
	import {
		productSpecs,
		productSpecsInfo
	} from "@/api/product";
	import Setting from "@/setting";
	import pdgoods from './pdgoods.vue'
	export default {
		name: "stocktakingAdd",
		components: {
			pdgoods
		},
		data() {
			return {
				loading: false,
				authList: [],
				columnss: [{
						title: '商品名称',
						key: 'product_name',
						minWidth: 160
					},
					{
						title: '要货数量',
						slot: 'want_product_num',
						minWidth: 90
					},
					{
						title: '要货单位',
						slot: 'unit_types',
						minWidth: 150
					},
					{
						title: '操作',
						slot: 'action',
						minWidth: 120
					},
				],
				columns: [{
						title: '商品名称',
						key: 'name',
						minWidth: 160
					},
					{
						title: '库存',
						key: 'product_num',
						minWidth: 90
					},
					{
						title: '单位',
						key: 'unit_name',
						minWidth: 90
					},
					{
						title: '数量',
						slot: 'pur_number',
						minWidth: 150
					},
					{
						title: '重量（kg）',
						slot: 'weight',
						minWidth: 120
					},
					{
						title: '操作',
						slot: 'action',
						minWidth: 120
					},

				],
				chooseGoods: [],
				staffData: [],
				addresData: [],
				props: {
					emitPath: false,
					multiple: false,
					checkStrictly: true,
					value: "id",
					label: "title"
				},
				propss: {
					emitPath: false,
					multiple: false,
					checkStrictly: true,
					value: "id",
					label: "name"
				},
				propsss: {
					emitPath: false,
					multiple: false,
					checkStrictly: true,
					value: "id",
					label: "staff_name"
				},
				roterPre: Setting.roterPre,
				data1: [],
				grid: {
					xl: 7,
					lg: 7,
					md: 12,
					sm: 24,
					xs: 24,
				},
				formValidate: {
					inType: 0,
					outType: 0,
					id: 0,
					wid: 0,
					store_id: 0,
					goods: [],
					my_store_id: 0,
					create_uid: 0,
					create_admin_id: 0,
				},
				ruleValidate1: {
					
				},
				ruleValidate: {
					store_id: [{
						type: "number",
						required: true,
						message: "请选择门店",
						trigger: "blur"
					}, ],
					to_store_id: [{
						type: "number",
						required: true,
						message: "请选择调入门店",
						trigger: "blur"
					}, ],
					wid: [{
						type: "number",
						required: true,
						message: "请选择调出仓库",
						trigger: "blur"
					}, ],
					to_wid: [{
						type: "number",
						required: true,
						message: "请选择调入仓库",
						trigger: "blur"
					}, ],
					create_uid: [{
						type: "number",
						required: true,
						message: "请选择创建人",
						trigger: "blur"
					}, ],
					// goods: [{
					// 	type: "array",
					// 	required: true,
					// 	message: "请选择商品",
					// 	trigger: "change"
					// }, ],
				},
			};
		},
		computed: {
			...mapState("admin/layout", ["isMobile", "menuCollapse"]),
			labelWidth() {
				return this.isMobile ? undefined : 120;
			},
			labelPosition() {
				return this.isMobile ? "top" : "right";
			},
		},
		created() {
			this.getGodownList()
			let data = {
				pid: 0
			}
			// this.cityInfo(data);
		},
		mounted() {
			// this.setCopyrightShow({
			// 	value: false
			// });
			this.staffList()
			if (this.$route.query.id != 0) {
				this.formValidate.id = this.$route.query.id
				this.getOutInfo(this.$route.query.id)
			}
		},
		destroyed() {
			// this.setCopyrightShow({
			// 	value: true
			// });
		},
		methods: {
			...mapMutations("admin/layout", ["setCopyrightShow"]),
			delGood(index) {
				this.chooseGoods.splice(index, 1)
			},
			delBatch(in1, in2) {
				console.log((in1, in2));
				this.chooseGoods[in1].batch.splice(in2, 1)
			},
			jyNum(a = 0, b = 0, item) {
				console.log(a, b, 'jiaoyan');
				if (a * 1 < b * 1) {
					item.pur_number = 0
					return this.$Message.error('输入值大于可调出商品的库存')
				}
			},
			getOutInfo(id) {
				getOutInfo(id).then(res => {
					let data = res.data
					if (data.wid) {
						this.formValidate.outType = 0
						this.formValidate.wid = data.wid*1
					} else {
						this.formValidate.outType = 1
						this.formValidate.store_id = data.store_id*1
					}
					if (data.to_wid) {
						this.formValidate.to_wid = data.to_wid*1
						this.formValidate.inType == 0
					} else {
						this.formValidate.inType == 1
						this.formValidate.to_store_id = data.to_store_id*1
					}
					this.getUserList()
					this.formValidate.create_uid = data.create_uid
					this.formValidate.create_admin_id = data.create_admin_id
					this.chooseGoods = data.product.map(item => {
						item.name = item.store_name
						item.product_id = item.id
						if(item.group.length > 0) {
							item.batch = item.group
						}else {
							item.batch = []
						}
						return item
					})
					// console.log(res, 'ddddd');
					// let data = res.data
					// this.formValidate.id = data.id
					// this.formValidate.create_uid = data.create_uid
					// this.chooseGoods = data.info
					// this.formValidate.store_id = data.store_id
					// console.log(this.formValidate.goods, 'this.formValidate.goods');
					// if (data.wid) {
					// 	this.formValidate.inType = 0
					// 	this.formValidate.wid = data.wid
					// 	this.getUserList({
					// 		wid: this.formValidate.wid
					// 	})
					// } else {
					// 	this.formValidate.inType = 1
					// 	this.getUserList({
					// 		store_id: this.formValidate.store_id
					// 	})
					// }
				})
			},
			setGoods(e) {
				console.log(e, '选择');
				// 校验商品是否重复
				if (this.chooseGoods.find(item => e.product_id == item.product_id)) {
					console.log('55');
					this.$refs.pdgoods.clearAll()
					return this.$Message.error('该商品已选择');
				} else {
					this.$refs.pdgoods.modals = false
					this.chooseGoods.push(e)
					console.log(this.chooseGoods,'this.chooseGoods');

				}
			},
			getGoods() {
				if(!this.formValidate.wid) {
					return this.$Message.error('请选择仓库')
				}
				this.$refs.pdgoods.formValidate.wid = this.formValidate.wid
				this.$refs.pdgoods.modals = true
				this.$refs.pdgoods.getList()

			},
			getUserList() {
				let qdata = {}
				if (this.formValidate.outType == 1) {
					qdata.store_id = this.formValidate.store_id
				} else {
					qdata.wid = this.formValidate.wid
				}
				getUserList(qdata).then(res => {
					// console.log(res);
					this.authList = res.data.data
					// .map(item => {
					// 		item.id += ''
					// 		return item
					// 	});
				})
			},
			staffList() {
				staffListInfo()
					.then((res) => {
						this.staffData = res.data
						// .map(item => {
						// 	item.id += ''
						// 	return item
						// });
					})
					.catch((err) => {
						this.$Message.error(err.msg);
					});
			},
			getGodownInfo(id) {
				getGodownInfo(id).then(res => {
					this.formValidate = res.data
					this.formValidate.addressSelect = this.formValidate.addressSelect.map(item => item * 1)
					console.log(this.formValidate.addressSelect);
				})
			},
			addchack(e, selectedData) {
				console.log(selectedData, 'selectedData');
				e.forEach((i, index) => {
					if (index == 0) {
						this.formValidate.province = i
					} else if (index == 1) {
						this.formValidate.city = i
					} else if (index == 2) {
						this.formValidate.area = i
					} else {
						this.formValidate.street = i
					}
				})
				this.formValidate.address = (selectedData.map(o => o.label)).join('/')
				// console.log('this.formValidate.addressSelect',this.formValidate.addressSelect);

			},
			cityInfo(data) {
				cityApi(data).then(res => {
					this.addresData = res.data
				})
			},
			loadData(item, callback) {
				item.loading = true;
				cityApi({
					pid: item.value
				}).then(res => {
					item.children = res.data;
					item.loading = false;
					callback();
				});


			},
			getGodownList() {
				getGodownList().then(res => {
					console.log(res);
					this.data1 = res.data.data
					// .map(item => {
					// 		item.id += ''
					// 		return item
					// 	});
				})
			},
			del(index) {
				this.chooseGoods.splice(index, 1);
			},
			userSearchse(e) {
				this.formValidate.create_uid = "";
				this.authList = []
				this.getUserList()
			},
			userSearchs(e) {
				this.formValidate.wid = 0
				this.goods = []
			},
			userSearchss(e) {
				this.formValidate.create_uid = "";
				this.formValidate.store_id = 0
				this.authList = []
				this.getUserList()
			},
			checkOutWare(e) {
				this.formValidate.create_uid = "";
				this.authList = []
				this.chooseGoods = []
				if (e) {
					this.getUserList()
				}
			},
			changeOutType(e) {
				this.formValidate.wid = 0
				this.formValidate.store_id = 0
				this.checkOutWare(0)
			},
			userSearchsss(e) {
				if (e) {
					let obj = this.authList.find(item => item.id == e)
					this.formValidate.create_admin_id = obj.admin_id
				}
			},
			checkWid(e) {

			},
			handleSubmit(name) {
				let that = this
				console.log(this.chooseGoods, '最后');
				this.$refs[name].validate((valid) => {
					if (valid) {
						this.formValidate.id = this.$route.query.id;

						// 校验商品数量和重量是否为0
						let errIndex = 0;
						that.chooseGoods.forEach(item => {
							if (item.batchs.length > 0) {
								// let errIndexs = 0;
								item.batchs.forEach(e => {
									console.log(e.stockValue,'e.stockValue');
									if (e.stockValue === undefined || e.stockValue === '') {
										errIndex++
									}
								})
							} else {
								// if (item.pur_number == 0) {
								// 	errIndex++
								// }
								// if (item.is_weigh == 1 && e.weight == 0) {
								// 	errIndex++
								// }
							}
						})
						if (errIndex > 0) {
							return that.$Message.error("实盘数量不能为空");
						}
						
						// pdata.product_list = that.chooseGoods
						console.log(that.chooseGoods,'that.chooseGoods');
						saveInventory({
							wid: this.formValidate.wid,
							body: this.chooseGoods,
							create_uid: this.formValidate.create_uid,
							create_admin_id: this.formValidate.create_admin_id
						}).then(res => {
								this.$Message.success(res.msg);
								this.$router.push({
									path: this.roterPre + "/erp/stocktaking"
								});
							}).catch(err => {
								this.$Message.error(err.msg);
							})
						
					} else {
						// this.$Message.error("请输入参数模板名称");
					}
				});
			},
		},
	};
</script>

<style scoped lang="stylus">
	.table {
		/deep/.ivu-table-header table {
			border: 0 !important;
		}

		/deep/.ivu-table-header thead tr th:nth-of-type(1) {
			padding-left: 16px;
		}

		/deep/.ivu-table td:nth-of-type(1) {
			padding-left: 16px;
		}

		/deep/.ivu-table-cell {
			padding: 0 !important;
		}

		/deep/.ivu-table-border th,
		/deep/.ivu-table-border td {
			border-right: unset;
		}

		/deep/.ivu-table td {
			height: 59px;
		}
	}

	.form-submit {
		/deep/.ivu-card {
			border-radius: 0;
		}

		margin-bottom: 79px;

		.fixed-card {
			position: fixed;
			right: 0;
			bottom: 0;
			left: 200px;
			z-index: 99;
			box-shadow: 0 -1px 2px rgb(240, 240, 240);

			/deep/ .ivu-card-body {
				padding: 15px 16px 14px;
			}

			.ivu-form-item {
				margin-bottom: 0;
			}

			/deep/ .ivu-form-item-content {
				margin-right: 124px;
				text-align: center;
			}

			.ivu-btn {
				height: 36px;
				padding: 0 20px;
			}
		}
	}

	.after-line {
		display: inline-block;
		position: relative;
		margin-right: 16px;
	}

	.ml16 {
		margin-left: 16px;
	}

	.user-info {
		position: relative;
		padding: 20px;

		.section {
			padding: 25px 25px;
			border-bottom: 1px dashed #EEEEEE;
			position: relative;

			&-hd {
				padding-left: 10px;
				border-left: 3px solid #1890FF;
				font-weight: 500;
				font-size: 14px;
				line-height: 16px;
				color: #303133;
			}

			&-bd {
				display: flex;
				flex-wrap: wrap;
			}

			.item {
				// flex: 0 0 calc(~"(100% - 60px) / 3");
				width: 25%;
				min-width: 250px;
				display: flex;
				margin: 16px 30px 0 0;
				font-size: 13px;
				color: #606266;

				&:nth-child(3n+3) {
					margin: 16px 0 0;
				}
			}

			.value {
				flex: 1;
			}

			.avatar {
				width: 60px;
				height: 60px;
				overflow: hidden;

				img {
					width: 100%;
					height: 100%;
				}
			}
		}
	}

	.del-btn {
		position: absolute;
		right: 20px;
		top: 10px;
	}

	.del-btn-1 {
		position: absolute;
		right: 80px;
		bottom: 20px;
	}
</style>